import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

public class DoubleBufferedPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	private Image bgImage;
	private Image buffer;
	
	public void setImage( Image img ) {
		bgImage = img;
	}
	
	public void update( Graphics g ) {
		paint ( g );
	}
	
	public void paint ( Graphics g ) {
		
		buffer = new BufferedImage ( this.getWidth(), this.getHeight(), 
				BufferedImage.TYPE_INT_RGB );
		Graphics bg = buffer.getGraphics();
		
		bg.setColor ( Color.BLACK );
		bg.clearRect( 0, 0, buffer.getWidth( null ), buffer.getHeight( null ) );
		
		if ( bgImage != null ) {
			int xoff = ( this.getWidth() - 512 ) / 2;
			int yoff = ( this.getHeight() - 512 ) / 2;
			
			bg.drawImage( bgImage, xoff, yoff, 512, 512, null );
		}
		
		g.drawImage( buffer, 0, 0, buffer.getWidth( null ), buffer.getHeight( null ), null );
		bg.dispose();
	}
	
}
